<!-- Spinner -->
<ngx-spinner [name]='"intents"' [fullScreen]="true" bdColor="#f5f5f583" size="medium" type="ball-fussion" color="#EDAE49"></ngx-spinner>

<!-- Navbar -->
<app-navbar></app-navbar>

<!-- Main Content -->
<div class="page">

    <!-- Intent Management -->
    <div class="card" style="padding: 2%">
        <!-- Title -->
        <mat-label style="display: flex; justify-content: center; margin-top: 4%; margin-bottom: 4%">
            <mat-icon style="margin-right: 9px">monitor</mat-icon>
            <h1>Intents Management</h1>
        </mat-label>

        <!-- Search -->
        <mat-form-field appearance="outline" style="margin-left: 2%; margin-right: 2%">
            <mat-label>Search...</mat-label>
            <input matInput (keyup)="applySearch($event)" placeholder="Search Intents..." #input />
        </mat-form-field>

        <!-- Create Intent Button -->
        <div class="row">
            <div class="col-lg-22">
                <button mat-raised-button id="create_button" class="btn-2"
                    type="button" (click)="createIntent()">
                    <span class="indicator-label">
                    <a> Create Intent </a>
                    </span>
                </button>
            </div>
        </div>

        <!-- CRUD Table -->
        <mat-table [dataSource]="dataSourceIntents" matSort matSortActive="id" matSortDirection="desc" matSortDisableClear
        class="mat-elevation-z8">
            <ng-container matColumnDef="id">
                <mat-header-cell class="cells" mat-header-cell *matHeaderCellDef mat-sort-header> ID </mat-header-cell>
                <mat-cell class="cells" mat-cell *matCellDef="let element">
                    {{ element.id }}
                </mat-cell>
            </ng-container>

            <ng-container matColumnDef="status">
                <mat-header-cell class="cells" mat-header-cell *matHeaderCellDef mat-sort-header> Status </mat-header-cell>
                <mat-cell class="cells" mat-cell *matCellDef="let element">
                    <mat-chip *ngIf="element.fulfilment_status === 'FULFILLED'" [removable]="false" class="status-chip" id="fulfilled">{{ element.fulfilment_status }}</mat-chip>
                    <mat-chip *ngIf="element.fulfilment_status === 'NOT_FULFILLED'" [removable]="false" class="status-chip" id="notfulfilled">{{ element.fulfilment_status }}</mat-chip>
                    <mat-chip *ngIf="element.fulfilment_status === 'NOT_FULFILLED'" [removable]="false" class="status-chip" id="reasonnotfulfilled">{{ element.not_fulfilled_state }}</mat-chip>
                </mat-cell>
            </ng-container>

            <ng-container matColumnDef="name">
                <mat-header-cell class="cells" mat-header-cell *matHeaderCellDef mat-sort-header> Intent Type </mat-header-cell>
                <mat-cell class="cells" mat-cell *matCellDef="let element"> {{ element.name }} </mat-cell>
            </ng-container>

            <ng-container matColumnDef="workload_instance_id">
                <mat-header-cell class="cells" mat-header-cell *matHeaderCellDef mat-sort-header> Workload Instance ID </mat-header-cell>
                <mat-cell class="cells" mat-cell *matCellDef="let element"> 
                    <mat-chip [removable]="false" (click)="copyToClipboard(element.workload_instance_id)">{{ element.workload_instance_id.substring(0, 7) }}...</mat-chip>
                </mat-cell>
            </ng-container>

            <ng-container matColumnDef="actions">
                <mat-header-cell class="cells" mat-header-cell *matHeaderCellDef mat-sort-header> Actions </mat-header-cell>
                <mat-cell class="cells" mat-cell *matCellDef="let element">
                    <!-- Report-->
                    <button mat-icon-button style="color: blue;" (click)="intentReport(element.whole_intent)" [disabled]="false"
                    matTooltip="Show Intent Report" matTooltipPosition="above">
                        <mat-icon> document_scanner </mat-icon>
                    </button>
                    <!-- Resume Intent -->
                    <button mat-icon-button color="primary" (click)="resumeIntent(element.id)" [disabled]="element.not_fulfilled_state !== 'SUSPENDED'"
                    matTooltip="Resume" matTooltipPosition="above">
                        <mat-icon> play_arrow </mat-icon>
                    </button>
                    <!-- Suspend Button -->
                    <button mat-icon-button color="primary" (click)="suspendIntent(element.id)" [disabled]="element.not_fulfilled_state === 'SUSPENDED' || element.not_fulfilled_state === 'TERMINATED'"
                    matTooltip="Suspend" matTooltipPosition="above">
                        <mat-icon> stop </mat-icon>
                    </button>
                    <!-- Terminate Workload -->
                    <button mat-icon-button color="warn" (click)="terminateIntent(element.id)" [disabled]="element.not_fulfilled_state === 'TERMINATED'"
                    matTooltip="Terminate" matTooltipPosition="above">
                        <mat-icon> delete </mat-icon>
                    </button>
                </mat-cell>
            </ng-container>

            <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
            <tr class="mat-row" *matNoDataRow>
                <td class="mat-cell" colspan="4">No Data</td>
            </tr>
            <mat-row matRipple *matRowDef="let row; columns: displayedColumns"
            [class.green]="row.treatmentGroup == 'Intervention'" [class.red]="row.treatmentGroup == 'Control'"
            [class.netrual]="row.treatmentGroup == 'text something e.g null'"></mat-row>
        </mat-table>
        
        <!-- Paginator -->
        <mat-paginator [pageSizeOptions]="[10, 25, 100]" aria-label="Select page of users"></mat-paginator>
    </div>
    
</div>

